Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 3636)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 3637)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3589 2018-11-30 15:09:51Z suehring
 ! Move the control parameter "salsa" from salsa_mod to control_parameters 
 ! (M. Kurppa)
@@ -245,12 +248,6 @@
         ONLY:  lv_d_cp
 
-    USE biometeorology_mod,                                                    &
-        ONLY:  bio_data_output_3d
-
     USE bulk_cloud_model_mod,                                                  &
-        ONLY:  bulk_cloud_model, bcm_data_output_3d
-
-    USE chemistry_model_mod,                                                   &
-        ONLY:  chem_data_output_3d
+        ONLY:  bulk_cloud_model
 
     USE control_parameters,                                                    &
@@ -263,7 +260,4 @@
     USE cpulog,                                                                &
         ONLY:  log_point, cpu_log
-
-    USE gust_mod,                                                              &
-        ONLY: gust_data_output_3d, gust_module_enabled
 
 #if defined( __parallel )
@@ -282,4 +276,7 @@
         ONLY: lsm_data_output_3d, nzb_soil, nzt_soil
 
+    USE module_interface,                                                      &
+        ONLY:  module_interface_data_output_3d
+
 #if defined( __netcdf )
     USE NETCDF
@@ -289,22 +286,13 @@
         ONLY:  fill_value, id_set_3d, id_var_do3d, id_var_time_3d, nc_stat,    &
                netcdf_data_format, netcdf_handle_error
-        
-    USE ocean_mod,                                                             &
-        ONLY:  ocean_data_output_3d
 
     USE particle_attributes,                                                   &
         ONLY:  grid_particles, number_of_particles, particles,                 &
                particle_advection_start, prt_count
-        
+
     USE pegrid
 
-    USE plant_canopy_model_mod,                                                &
-        ONLY:  pcm_data_output_3d
-        
     USE radiation_model_mod,                                                   &
-        ONLY:  nzub, nzut, radiation, radiation_data_output_3d
-               
-    USE salsa_mod,                                                             &
-        ONLY:  salsa_data_output_3d     
+        ONLY:  nzub, nzut
 
     USE turbulence_closure_mod,                                                &
@@ -399,22 +387,15 @@
 
 !
-!--    Temporary solution to account for data output within the new urban 
+!--    Initiate found flag and resorting flag
+       found = .FALSE.
+       resorted = .FALSE.
+!
+!--    Temporary solution to account for data output within the new urban
 !--    surface model (urban_surface_mod.f90), see also SELECT CASE ( trimvar ).
 !--    Store the array chosen on the temporary array.
+       nzb_do   = nzb
+       nzt_do   = nz_do3d
+
        trimvar = TRIM( do3d(av,ivar) )
-       IF ( urban_surface  .AND.  trimvar(1:4) == 'usm_' )  THEN
-          trimvar = 'usm_output'
-          resorted = .TRUE.
-          nzb_do   = nzub
-          nzt_do   = nzut
-       ELSE
-          resorted = .FALSE.
-          nzb_do   = nzb
-          nzt_do   = nz_do3d
-       ENDIF
-!
-!--    Set flag to steer output of radiation, land-surface, or user-defined
-!--    quantities
-       found = .FALSE.
 !
 !--    Allocate a temporary array with the desired output dimensions.
@@ -715,37 +696,29 @@
                 to_be_resorted => w_av
              ENDIF
-!             
-!--       Block of urban surface model outputs   
-          CASE ( 'usm_output' )
-             CALL usm_data_output_3d( av, do3d(av,ivar), found, local_pf,        &
-                                         nzb_do, nzt_do )
 
           CASE DEFAULT
 
-!
-!--          Quantities of other modules
-             IF ( .NOT. found  .AND.  bulk_cloud_model )  THEN
-                CALL bcm_data_output_3d( av, do3d(av,ivar), found, local_pf,     &
+             IF ( .NOT. found )  THEN
+                CALL tcm_data_output_3d( av, trimvar, found, local_pf,   &
                                          nzb_do, nzt_do )
                 resorted = .TRUE.
              ENDIF
 
-             IF ( .NOT. found  .AND.  air_chemistry )  THEN
-                CALL chem_data_output_3d( av, do3d(av,ivar), found,              &
-                                          local_pf, fill_value, nzb_do, nzt_do )
-                resorted = .TRUE.
-             ENDIF
-
-             IF ( .NOT. found  .AND.  gust_module_enabled )  THEN
-                CALL gust_data_output_3d( av, do3d(av,ivar), found, local_pf,    &
-                                          nzb_do, nzt_do )
-                resorted = .TRUE.
-             ENDIF
-
-             IF ( .NOT. found  .AND.  land_surface )  THEN
-!
-!--             For soil model quantities, it is required to re-allocate local_pf
-                nzb_do = nzb_soil
-                nzt_do = nzt_soil
+!
+!--          Quantities of other modules
+             IF ( .NOT. found )  THEN
+                CALL module_interface_data_output_3d(                          &
+                        av, trimvar, found, local_pf,                          &
+                        fill_value, resorted, nzb_do, nzt_do                   &
+                     )
+             ENDIF
+
+!
+!--          Temporary workaround: ToDo: refactor local_pf allocation
+             IF ( .NOT. found  .AND.  urban_surface  .AND.  trimvar(1:4) == 'usm_' )  THEN
+!
+!--             For urban model quantities, it is required to re-allocate local_pf
+                nzb_do = nzub
+                nzt_do = nzut
 
                 DEALLOCATE ( local_pf )
@@ -753,5 +726,6 @@
                 local_pf = fill_value
 
-                CALL lsm_data_output_3d( av, do3d(av,ivar), found, local_pf )
+                CALL usm_data_output_3d( av, trimvar, found, local_pf,         &
+                                         nzb_do, nzt_do )
                 resorted = .TRUE.
 
@@ -763,52 +737,34 @@
 
                    DEALLOCATE ( local_pf )
-                   ALLOCATE( local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do) )                 
-                ENDIF
-
-             ENDIF
-
-             IF ( .NOT. found  .AND.  ocean_mode )  THEN
-                CALL ocean_data_output_3d( av, do3d(av,ivar), found, local_pf,   &
-                                           nzb_do, nzt_do )
+                   ALLOCATE( local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do) )
+                ENDIF
+
+             ENDIF
+
+!
+!--          Temporary workaround: ToDo: refactor local_pf allocation
+             IF ( .NOT. found  .AND.  land_surface )  THEN
+!
+!--             For soil model quantities, it is required to re-allocate local_pf
+                nzb_do = nzb_soil
+                nzt_do = nzt_soil
+
+                DEALLOCATE ( local_pf )
+                ALLOCATE( local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do) )
+                local_pf = fill_value
+
+                CALL lsm_data_output_3d( av, trimvar, found, local_pf )
                 resorted = .TRUE.
-             ENDIF
-
-             IF ( .NOT. found  .AND.  plant_canopy )  THEN
-                CALL pcm_data_output_3d( av, do3d(av,ivar), found, local_pf,     &
-                                         fill_value, nzb_do, nzt_do )
-                resorted = .TRUE.
-             ENDIF
-
-             IF ( .NOT. found  .AND.  radiation )  THEN
-                CALL radiation_data_output_3d( av, do3d(av,ivar), found,         &
-                                               local_pf, nzb_do, nzt_do )
-                resorted = .TRUE.
-             ENDIF
-
-             IF ( .NOT. found )  THEN
-                CALL tcm_data_output_3d( av, do3d(av,ivar), found, local_pf,     &
-                                         nzb_do, nzt_do )
-                resorted = .TRUE.
-             ENDIF
-             
-!
-!--          SALSA output
-             IF ( .NOT. found  .AND.  salsa )  THEN
-                CALL salsa_data_output_3d( av, do3d(av,ivar), found, local_pf, &
-                                           nzb_do, nzt_do )
-                resorted = .TRUE.
-             ENDIF                  
-
-             IF ( .NOT. found  .AND.  biometeorology )  THEN
-                 CALL bio_data_output_3d( av, do3d(av,ivar), found, local_pf,    &
-                                          nzb_do, nzt_do )
-             ENDIF
-
-!
-!--          User defined quantities
-             IF ( .NOT. found )  THEN
-                CALL user_data_output_3d( av, do3d(av,ivar), found, local_pf,    &
-                                          nzb_do, nzt_do )
-                resorted = .TRUE.
+
+!
+!--             If no soil model variable was found, re-allocate local_pf
+                IF ( .NOT. found )  THEN
+                   nzb_do = nzb
+                   nzt_do = nz_do3d
+
+                   DEALLOCATE ( local_pf )
+                   ALLOCATE( local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do) )
+                ENDIF
+
              ENDIF
 
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 3636)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 3637)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3458 2018-10-30 14:51:23Z kanani
 ! from chemistry branch r3443, basit:
 ! bug fixed in chemistry profiles
@@ -309,10 +312,9 @@
         ONLY:  g, lv_d_cp
 
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
 
     USE chem_modules,                                                          &
         ONLY:  max_pr_cs
-
-    USE chemistry_model_mod,                                                   &
-        ONLY:  chem_species, chem_statistics
 
     USE control_parameters,                                                    &
@@ -330,7 +332,4 @@
     USE grid_variables,                                                        &
         ONLY:   ddx, ddy
-
-    USE gust_mod,                                                              &
-        ONLY:  gust_module_enabled, gust_statistics
         
     USE indices,                                                               &
@@ -340,7 +339,4 @@
         
     USE kinds
-
-    USE bulk_cloud_model_mod,                                                  &
-        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
     
     USE land_surface_model_mod,                                                &
@@ -349,4 +345,7 @@
     USE lsf_nudging_mod,                                                       &
         ONLY:   td_lsa_lpt, td_lsa_q, td_sub_lpt, td_sub_q, time_vert
+
+    USE module_interface,                                                      &
+        ONLY:  module_interface_statistics
 
     USE netcdf_interface,                                                      &
@@ -1795,18 +1794,8 @@
           ENDDO
        ENDIF
-!
-!--    Calculate the gust module profiles
-       IF ( gust_module_enabled )  THEN
-          CALL gust_statistics( 'profiles', sr, tn, dots_max )
-       ENDIF
-!
-!--    Calculate the chemistry module profiles
-       IF ( air_chemistry ) THEN
-          CALL chem_statistics( 'profiles', sr, tn )
-       ENDIF
-!
-!--    Calculate the user-defined profiles
-       CALL user_statistics( 'profiles', sr, tn )
-       !$OMP END PARALLEL
+
+!
+!--    Calculate the profiles for all other modules
+       CALL module_interface_statistics( 'profiles', sr, tn, dots_max )
 
 !
@@ -2268,12 +2257,6 @@
 
 !
-!--    Calculate additional statistics provided by the gust module
-       IF ( gust_module_enabled )  THEN
-          CALL gust_statistics( 'time_series', sr, 0, dots_max )
-       ENDIF
-
-!
-!--    Calculate additional statistics provided by the user interface
-       CALL user_statistics( 'time_series', sr, 0 )
+!--    Calculate additional statistics provided by other modules
+       CALL module_interface_statistics( 'time_series', sr, 0, dots_max )
 
     ENDDO    ! loop of the subregions
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 3636)
+++ palm/trunk/SOURCE/header.f90	(revision 3637)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of the PALM module interface
+! 
+! 3589 2018-11-30 15:09:51Z suehring
 ! Move the control parameter "salsa" from salsa_mod to control_parameters 
 ! (M. Kurppa)
@@ -420,12 +423,6 @@
         ONLY:  g, kappa, l_v
 
-    USE biometeorology_mod,                                                    &
-        ONLY:  bio_header
-
     USE bulk_cloud_model_mod,                                                  &
-        ONLY:  bulk_cloud_model, bcm_header
-
-    USE chemistry_model_mod,                                                   &
-        ONLY:  chem_header
+        ONLY:  bulk_cloud_model
 
     USE control_parameters
@@ -439,37 +436,25 @@
     USE dvrp_variables,                                                        &
         ONLY:  use_seperate_pe_for_dvrp_output
-        
-    USE flight_mod,                                                            &
-        ONLY:  flight_header
-        
+
     USE grid_variables,                                                        &
         ONLY:  dx, dy
-
-    USE gust_mod,                                                              &
-        ONLY: gust_header, gust_module_enabled
 
     USE indices,                                                               &
         ONLY:  mg_loc_ind, nnx, nny, nnz, nx, ny, nxl_mg, nxr_mg, nyn_mg,      &
                nys_mg, nzt, nzt_mg
-        
+
     USE kinds
- 
-    USE land_surface_model_mod,                                                &
-        ONLY: lsm_header
-
-    USE lsf_nudging_mod,                                                       &
-        ONLY:  lsf_nudging_header
 
     USE model_1d_mod,                                                          &
         ONLY:  damp_level_ind_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
 
+    USE module_interface,                                                      &
+        ONLY:  module_interface_header
+
     USE netcdf_interface,                                                      &
         ONLY:  netcdf_data_format, netcdf_data_format_string, netcdf_deflate
 
-    USE nesting_offl_mod,                                                      &
-        ONLY:  nesting_offl_header
-
     USE ocean_mod,                                                             &
-        ONLY:  ibc_sa_t, ocean_header, prho_reference, sa_surface,             &
+        ONLY:  ibc_sa_t, prho_reference, sa_surface,                           &
                sa_vertical_gradient, sa_vertical_gradient_level,               &
                sa_vertical_gradient_level_ind
@@ -487,9 +472,6 @@
                total_number_of_particles, use_sgs_for_particles,               &
                vertical_particle_advection, write_particle_statistics
-        
+
     USE pegrid
-
-    USE plant_canopy_model_mod,                                                &
-        ONLY:  pcm_header
 
 #if defined( __parallel )
@@ -501,18 +483,6 @@
         ONLY:  nested_run, nesting_datatransfer_mode, nesting_mode
 
-    USE radiation_model_mod,                                                   &
-        ONLY:  radiation, radiation_header
-               
-    USE salsa_mod,                                                             &
-        ONLY:  salsa_header        
-    
-    USE spectra_mod,                                                           &
-        ONLY:  calculate_spectra, spectra_header
-
     USE surface_mod,                                                           &
         ONLY:  surf_def_h, get_topography_top_index_ji
-
-    USE synthetic_turbulence_generator_mod,                                    &
-        ONLY:  stg_header
 
     USE turbulence_closure_mod,                                                &
@@ -935,12 +905,4 @@
 
 !
-!-- Large scale forcing and nudging
-    IF ( large_scale_forcing )  CALL lsf_nudging_header( io )
-
-!
-!-- Offline nesting 
-    IF ( nesting_offline )  CALL nesting_offl_header( io )
-
-!
 !-- Profile for the large scale vertial velocity
 !-- Building output strings, starting with surface value
@@ -1161,16 +1123,4 @@
        ENDIF
     ENDIF
-
-!
-!-- Header information from other modules
-    IF ( biometeorology      )  CALL bio_header ( io )
-    IF ( gust_module_enabled )  CALL gust_header( io )
-    IF ( land_surface        )  CALL lsm_header( io )
-    IF ( ocean_mode          )  CALL ocean_header( io )
-    IF ( plant_canopy        )  CALL pcm_header( io )
-    IF ( radiation           )  CALL radiation_header( io )
-    IF ( syn_turb_gen        )  CALL stg_header( io )
-
-    IF ( air_chemistry )  CALL chem_header ( io )
 !
 !-- Boundary conditions
@@ -1924,11 +1874,5 @@
     ENDIF
 #endif
-!
-!-- Output of virtual flight information
-    IF ( virtual_flight )  CALL flight_header( io )
-
-!
-!-- Output of spectra related quantities
-    IF ( calculate_spectra )  CALL spectra_header( io )
+
 
     WRITE ( io, 99 )
@@ -1958,8 +1902,4 @@
        ENDIF
     ENDIF
-
-!
-!-- Output of microphysics information
-    IF ( bulk_cloud_model )  CALL bcm_header( io )
 
 !
@@ -2083,12 +2023,9 @@
        ENDIF
     ENDIF
-    
-!
-!-- SALSA information
-    IF ( salsa )  CALL salsa_header( io ) 
-
-!
-!-- User-defined information
-    CALL user_header( io )
+
+!
+!-- Header information from other modules
+    CALL module_interface_header( io )
+
 
     WRITE ( io, 99 )
